<template>
  <div>
    <div class="content-top">
      <div class="title-content">
        {{ $t('dashboard.history.title') }}
      </div>
      <div class="balance__estimated">
        <span class="estimated__text">{{ $t('dashboard.history.balances') }}:</span>
        <span class="estimated__number">{{ hetaTokensWallet.balance | formatCurrencyAmount('heta', '0') }} HETA Token</span>
      </div>
    </div>

    <table class="balance-table">
      <thead>
        <tr>
          <th>{{ $t('dashboard.history.currency') }}</th>
          <th>{{ $t('dashboard.history.amount') }}</th>
          <th>HETA Token</th>
          <th>{{ $t('dashboard.history.bonus_token') }}</th>
          <th>{{ $t('dashboard.history.time') }}</th>
        </tr>
      </thead>
      <tbody v-if="conversions.length > 0">
        <tr v-for="conversion in conversions">
          <td class="coin">
            <img :src="conversion.currency | currencyIcon" :alt="conversion.currency" class="coin__image">
            <span class="coin__name">{{ conversion.currency | uppercase }}</span>
            <span class="coin__fullname" v-if="!isTablet"> - {{ conversion.currency | fullname }}</span>
          </td>
          <td class="amount">{{ conversion.currency_amount | formatCurrencyAmount(conversion.currency, '0') }} {{ conversion.currency | uppercase }}</td>
          <td class="hetaToken">{{ conversion.token_amount | formatCurrencyAmount('heta', '0') }}</td>
          <td class="bonusToken">{{ conversion.bonus_amount | formatCurrencyAmount('heta', '0') }}</td>
          <td class="time">{{ formatDate(conversion) }}</td>
        </tr>
      </tbody>
      <div class="not-found" v-else>
        <span class="iconmo-not-found not-found__icon"></span>
        <span class="not-found__text">{{ $t('dashboard.history.not_found_text') }}</span>
      </div>
    </table>
  </div>
</template>

<script>
  import { mapState, mapGetters } from 'vuex';
  import moment from 'moment';
  import MobileDetect from 'mobile-detect';

  import rf from '../../../common/requests/RequestFactory';

  export default {
    data() {
      return {
        conversions: [],
      }
    },
    computed: {
      ...mapGetters(['hetaTokensWallet']),
      ...mapState([
        'user',
      ]),
      isTablet() {
        const md = new MobileDetect(window.navigator.userAgent);
        return md.tablet();
      }
    },
    methods: {
      async getConversions () {
        if (this.user) {
          const res = await rf.getRequest('ConversionRequest').getAll();
          this.conversions = [...res.data];
        }
      },
      formatDate (transaction) {
        if (this.isTablet) {
          return moment(transaction.created_at).format('MM-DD HH:mm');
        }
        return moment(transaction.created_at).format('YYYY-MM-DD HH:mm:ss');
      },
    },
    watch: {
      user () {
        this.getConversions();
      },
    },
    created () {
      this.$on('ConversionCreated', (conversion) => {
        this.conversions.unshift(conversion);
      });
      this.getConversions();
    },
  }
</script>
<style scoped lang="scss">
  @import '../../../../sass/variables';
  @import '../../../../sass/vendor/position';

  tbody {
    display: block;
    height: 350px;
    overflow: auto;
    -ms-overflow-style: none;  // IE 10+
    overflow: -moz-scrollbars-none;  // Firefox
    overflow-y: auto;
    &::-webkit-scrollbar {
      display: none;  // Safari and Chrome
    }
  }
  thead, tbody tr {
    display: table;
    width: 100%;
    table-layout: fixed;
  }

  .content-top {
    font-size: 0;
    margin-bottom: 15px;
  }

  .title-content {
    padding-left: 30px;
    font-size: $big;
    font-weight: bold;
    color: $white;
    display: inline-block;
    width: 30%;
  }

  .balance__estimated {
    display: inline-block;
    width: 70%;
    text-align: right;
    .estimated__text {
      font-size: $small;
      font-weight: 300;
      color: $thin_gray;
    }

    .estimated__number {
      font-size: $medium;
      font-weight: bold;
      color: $orange;
      padding-right: 9px;

      &:not(:first-child) {
        padding-left: 5px;
      }

      &:not(:last-child) {
        border-right: 1px solid #b0b0b0;
      }
    }
  }

  .balance-table {
    width: 100%;
    position: relative;

    &:before {
      content: '';
      display: block;
      position: absolute;
      top: 0;
      left: 0;
      height: 50px;
      width: 100%;
      border-radius: 30px;
      background-color: #2f2f54;
      z-index: -1;
    }

    thead {
      position: relative;

      tr th {
        padding: 14px 25px;
        font-weight: 500;
        font-size: $small;
        color: $thin_gray;
        width: 20%;
      }
    }

    tbody {
      tr {
        td {
          padding: 21px 0px 6px 30px;
        }

        &:not(:last-child) {
          border-bottom: 1px solid #2f2f54;
        }
      }
    }

    .coin {
      .coin__image {
        margin-right: 10px;
        width: 20px;
        height: 20px;      }

      .coin__name {
        font-weight: bold;
        font-size: $small;
        color: #cacaca;
      }
      .coin__fullname {
        font-size: $small;
        color: #cacaca;
      }
    }

    .amount,
    .coin__fullname {
      text-transform: capitalize;
    }

    .amount,
    .time,
    .hetaToken,
    .bonusToken {
      font-size: $small;
      font-weight: bold;
      color: #cacaca;
    }
  }
  .not-found {
    margin-top: 50px;
    text-align: center;
    .not-found__icon {
      padding: 25px;
      background-color: #242644;
      border-radius: 50%;
      font-size: 110px;
      display: inline-block;
      margin-bottom: 15px;
    }

    .not-found__text {
      display: block;
      font-size: 20px;
      color: $thin_gray;
    }
  }
</style>
